'$DYNAMIC
DEFINT A-Z

'WARNING: Never edit this file inside QB environment or else
'         you will encounter a "Line too long" message when
'         you try to compile your program.
'         Please use EDIT.COM or another text editor.

'If you need reference, please see MANUAL.TXT for more detailed information.

'The following lines may not be modified

TYPE RegType
 AX AS INTEGER
 BX AS INTEGER
 cx AS INTEGER
 dx AS INTEGER
 bp AS INTEGER
 si AS INTEGER
 di AS INTEGER
 flags AS INTEGER
END TYPE

TYPE RegtypeX
 AX AS INTEGER
 BX AS INTEGER
 cx AS INTEGER
 dx AS INTEGER
 bp AS INTEGER
 si AS INTEGER
 di AS INTEGER
 flags AS INTEGER
 ds AS INTEGER
 es AS INTEGER
END TYPE

TYPE DTAStructure
 DOS AS STRING * 19
 CreateTime AS STRING * 1
 Attributes AS INTEGER
 AccessTime AS INTEGER
 AccessDate AS INTEGER
 FileSize AS LONG
 FileName AS STRING * 13
END TYPE

TYPE XFCBType
 XFlag AS STRING * 1
 Rsrv1 AS STRING * 5
 Attr AS STRING * 1
 drive AS STRING * 1
 FName AS STRING * 11
 Rsrv2 AS STRING * 5
 NName AS STRING * 11
 Rsrv3 AS STRING * 9
END TYPE

TYPE slic
 x1 AS INTEGER
 y1 AS INTEGER
END TYPE

TYPE area
 x1 AS INTEGER
 x2 AS INTEGER
 y1 AS INTEGER
 y2 AS INTEGER
 itype AS INTEGER
 turbo AS INTEGER

 back AS INTEGER
 fieldfore AS INTEGER
 undercol AS INTEGER
 fieldeffect AS INTEGER
 fontcolor AS INTEGER

 click AS INTEGER
 click2 AS INTEGER

 colom AS INTEGER
 pcolom AS INTEGER
 char AS INTEGER
 scrol AS INTEGER
 gputy AS INTEGER
 memscr AS INTEGER
 mempoint AS INTEGER

 mskey AS INTEGER
 iscombo AS INTEGER
 msalt AS INTEGER
 cb AS INTEGER

 listindex AS INTEGER
END TYPE

TYPE winp
  x1 AS INTEGER
  x2 AS INTEGER
  y1 AS INTEGER
  y2 AS INTEGER
END TYPE

TYPE MouseCursor
  HotSpotX AS INTEGER
  HotSpotY AS INTEGER
  Image AS STRING * 64
END TYPE

TYPE FontHeader
  Ident AS STRING * 6
  with AS INTEGER
  Hite AS INTEGER
  Descriptor AS STRING * 20
END TYPE

TYPE coor
  x1 AS INTEGER
  y1 AS INTEGER
  x2 AS INTEGER
  y2 AS INTEGER
  sy1 AS INTEGER
  sy2 AS INTEGER
END TYPE

TYPE boun
  y1 AS INTEGER
  y2 AS INTEGER
END TYPE
 
'QB include routines

DECLARE SUB INTERRUPT (INTNUM AS INTEGER, inreg AS RegType, outreg AS RegType)
DECLARE SUB INTERRUPTX (INTNUM AS INTEGER, inreg AS RegtypeX, outreg AS RegtypeX)
DECLARE SUB INT86OLD (INTNUM AS INTEGER, inarray() AS INTEGER, outarray() AS INTEGER)
DECLARE SUB INT86XOLD (INTNUM AS INTEGER, inarray() AS INTEGER, outarray() AS INTEGER)
DECLARE SUB INT86 (INTNUM%, REGS AS ANY)

'Image viewer routines

DECLARE SUB LoadIcon (FileName$, x%, y%, disablecolor%)
DECLARE SUB LoadBmp (file.bmp$)

'Box routines

DECLARE SUB Box1 (x%, y%, x2%, y2%, colour%) ' Drop down like box
DECLARE SUB Box2 (x%, y%, x2%, y2%, colour%) ' edit like box
DECLARE SUB Box3 (x%, y%, x2%, y2%, colour%) ' Sink box
DECLARE SUB Box4 (x%, y%, x2%, y2%, colour%) ' Button like box

DECLARE SUB Line2 (x%, y%, x2%, y2%, colour%, steps%)
DECLARE SUB Line3 (x%, y%, x2%, y2%) '2D Line

'Objects

DECLARE SUB ListBox (x%, y%, num.of.line%, width.in.char%, strarray() AS STRING, controlid%)
DECLARE SUB EditBox (x%, y%, num.of.line%, width.in.char%, strarray() AS STRING, controlid%)
DECLARE SUB CheckBox (field$, x%, y%, fieldposition%, controlid%)
DECLARE SUB SpinBox (field$, fieldposition%, x%, y%, width.in.char%, controlid%)
DECLARE SUB ComboBox (field$, fieldposition%, x%, y%, width.in.char%, controlid%)
DECLARE SUB TextBox (field$, fieldposition%, x%, y%, width.in.char%, controlid%)
DECLARE SUB OptionCirc (optioncount%, x%, y%, fieldposition%, distance%, horizontal%, controlid%)
DECLARE SUB Button (caption$, x%, y%, x2%, y2%, controlid%)
DECLARE SUB Button2 (caption$, x%, y%, x2%, y2%, controlid%)
DECLARE SUB PageFrame (x%, y%, x2%, y2%, controlid%)
DECLARE SUB Menu (x%, y%, horizontal%, distance%, fonteffect%, fontcolour%, underlinecolour%, controlid%)
DECLARE SUB Label (caption$, x%, y%, pixelheight%, pixelwidth%, fonteffect%, fontcolour%, backcolour%, controlid%)
DECLARE SUB Win (x%, y%, x2%, y2%, withhelp%, title$, titlecolour%, backcolour%, windowcolour%, subwindow%, controlid%)
DECLARE SUB Win2 (x%, y%, x2%, y2%, withhelp%, title$, titlecolour%, backcolour%, windowcolour%, bordercolour%, subwindow%, controlid%)
DECLARE SUB CoolBar (x1%, y1%, x2%, y2%, withname%, fontcolour%, background%, fonteffect%, controlid%)

'Dialog box
DECLARE FUNCTION MsgBox% (title$, titlefore%, titleback%, msgcolour%, wincolour%, bordercolour%, buttoncount%)

'Object Control

DECLARE FUNCTION List.Cont$ (strarray() AS STRING, highlfore%, highlback%, controlid%)
DECLARE SUB Edit.Cont (strarray() AS STRING, controlid%)
DECLARE SUB View.Cont (strarray() AS STRING, controlid%)
DECLARE SUB Check.Cont (var%, controlid%)
DECLARE SUB Spin.Cont (var$, minvalue%, maxvalue%, edit%, controlid%)
DECLARE SUB Combo.Cont (var$, strarray() AS STRING, maxchar%, edit%, num.of.line%, withscrollbar%, listfore%, listback%, highlfore%, highlback%, controlid%)
DECLARE SUB Text.Cont (var$, maxchar%, controlid%)
DECLARE SUB Option.Cont (var%, optioncount%, controlid%)
DECLARE FUNCTION Button.Cont (controlid%)
DECLARE SUB Page.Cont (var%, pagecount%, controlid%)
DECLARE SUB Menu.Cont (var%, menucount%, controlid%)
DECLARE SUB UpdateLabel (caption$, controlid%)
DECLARE FUNCTION SubMenu% (forecol%, backcol%, effect%, highlfore%, highlback%, controlid%)
DECLARE SUB GetControl ()
DECLARE SUB Cool.Cont (var%, buttoncount%, controlid%)

'Control related routines

DECLARE FUNCTION FreeControl ()
DECLARE FUNCTION Click (controlid%)
DECLARE SUB SetProperties (controlid%, fieldcolour%, inputfontcolour%, inputbackcolour%, fieldeffect%, underlinecolour%)
DECLARE SUB SetMsg (message$, controlid%)
DECLARE SUB SetDataEntry (strexpression$) ' # = numeric string, $ = alphanumeric string, & = capital letter, @ = small letter, ! = special character, % + character = hide input as character
DECLARE SUB SetGridlineFocus (onoff%) ' 1 = ON, 0 = OFF

DECLARE SUB Text.Enable (var$, controlid%)
DECLARE SUB Text.Disable (var$, controlid%)
DECLARE SUB Combo.Enable (var$, controlid%)
DECLARE SUB Combo.Disable (var$, controlid%)
DECLARE SUB Spin.Enable (var$, controlid%)
DECLARE SUB Spin.Disable (var$, controlid%)
DECLARE SUB Check.Enable (var%, controlid%)
DECLARE SUB Check.Disable (var%, controlid%)
DECLARE SUB Option.Enable (var%, optioncount%, controlid%)
DECLARE SUB Option.Disable (var%, optioncount%, controlid%)
DECLARE SUB Button.Enable (caption$, controlid%)
DECLARE SUB Button.Disable (caption$, controlid%)
DECLARE SUB Edit.Disable (strarray() AS STRING, controlid%)
DECLARE SUB Edit.Enable (strarray() AS STRING, controlid%)
DECLARE SUB List.Disable (strarray() AS STRING, controlid%)
DECLARE SUB List.Enable (strarray() AS STRING, controlid%)

DECLARE FUNCTION Disabled (controlid%)
DECLARE FUNCTION Enabled (controlid%)

DECLARE FUNCTION PageFirstime ()

DECLARE SUB UpdateEdit (strarray() AS STRING, resets%, controlid%)
DECLARE SUB EditUp (num.of.lines%, strarray() AS STRING, controlid%)
DECLARE SUB EditDown (num.of.lines%, strarray() AS STRING, controlid%)
DECLARE SUB UpdateList (strarray() AS STRING, resets%, controlid%)
DECLARE SUB ListUp (num.of.lines%, strarray() AS STRING, controlid%)
DECLARE SUB ListDown (num.of.lines%, strarray() AS STRING, controlid%)
DECLARE SUB ViewUp (num.of.lines%, strarray() AS STRING, controlid%)
DECLARE SUB ViewDown (num.of.lines%, strarray() AS STRING, controlid%)

DECLARE FUNCTION EditSearch (phrase$, start.at.top%, sensitivity%, viewpos%, strarray() AS STRING, controlid%)
DECLARE FUNCTION ListSearch (phrase$, start.at.top%, sensitivity%, viewpos%, strarray() AS STRING, controlid%)

DECLARE SUB ErInp (controlid%)
DECLARE SUB PutChar (var$, controlid%)
DECLARE SUB SetOption (option.number%, controlid%)
DECLARE SUB Check (controlid%)
DECLARE SUB UnCheck (controlid%)
DECLARE SUB SetPage (pagenum%, pagecount%, controlid%)
DECLARE SUB SetAlt (field$, x%, y%, fonteffect%, fontcolour%, underlinecolour%, controlid%)
DECLARE SUB SaveControl ()
DECLARE SUB RestoreControl ()
DECLARE SUB SetFocus (controlid%)
DECLARE SUB UnControl (controlid%)
DECLARE SUB ReControl (controlid%)
DECLARE SUB ErControl (controlid%)
DECLARE SUB SaveScr (x%, y%, x2%, y2%)
DECLARE SUB RestoreScr ()
DECLARE FUNCTION list.index% (controlid%)
DECLARE SUB FocusOff ()

'Array related routines

DECLARE SUB ErList ()
DECLARE SUB Sort (strarray() AS STRING, ascending%)
DECLARE SUB QuickSort (strarray() AS STRING)

'Disk/File routines

DECLARE FUNCTION FloppyDriveList$ ()
DECLARE FUNCTION HardDriveList$ (Floppies$)
DECLARE FUNCTION DirX% (Dirspec$, Filter%, SearchType%)
DECLARE SUB MakeLabel (drive$, newlabel$)
DECLARE SUB ReadLabel (drive$, var$)
DECLARE FUNCTION Drv.FreeSpace# (drive$)
DECLARE FUNCTION Drv.TotalSpace# (drive$)
DECLARE FUNCTION CurrDir$ ()
DECLARE FUNCTION CurrDrv$ ()
DECLARE SUB ChDrv (drive$)
DECLARE FUNCTION Exist% (FILESPEC$)

'XMS Routines

DECLARE SUB FREEXMS ()
DECLARE SUB XMSGET (x%, y%, x2%, y2%, var%)
DECLARE SUB XMSPUT (x%, y%, var%)
DECLARE SUB MOV2XMS (BYVAL segm, BYVAL offs, BYVAL handle%, BYVAL length&)
DECLARE SUB MOV2RAM (BYVAL segm, BYVAL offs, BYVAL handle%, BYVAL length&)
DECLARE SUB XMSresize (BYVAL handle%, BYVAL newkb%)
DECLARE SUB XMSFREE (BYVAL handle%)
DECLARE SUB XMSinfo (totalmem%, largestblock%)
DECLARE FUNCTION XMSalloc% (BYVAL kbytes%)
DECLARE FUNCTION XMSinit% ()

'Mouse routines

DECLARE FUNCTION Mouseinit% ()
DECLARE SUB MouseDriver (AX%, BX%, cx%, dx%)
DECLARE SUB mousestatus (LB%, RB%, Xmouse%, Ymouse%)
DECLARE SUB WaitLBoff ()
DECLARE SUB SetPointer (pointernumber%)
DECLARE SUB Mhide ()
DECLARE SUB Mshow ()

'Misc.

DECLARE FUNCTION AllTrim$ (var$)
DECLARE SUB Font (text$, Xstart%, YStart%, Xscale%, Yscale%, style%, colour%)
DECLARE SUB OCenter (text$, x%, y%, style%, colour%)
DECLARE SUB WaitKey (ascii$)
DECLARE SUB ClearKeyboard ()
DECLARE SUB ScreenOff ()
DECLARE SUB ScreenOn ()

'Global variables

COMMON SHARED leftrig, pwinpos() AS INTEGER, winpos() AS winp, fontbuf() AS STRING * 16384, DataString() AS INTEGER, area1%(), chr() _
                                                                                                                                                                                                                                                           _
AS STRING, tempo AS STRING * 64, CURSOR() AS MouseCursor, INTRPT(), REGS AS RegtypeX, mscr, m() AS area, memo() AS STRING, slice() AS slic, lists() AS STRING, alt() AS INTEGER, active, mouseret, nomemscr, allmemo, emp, lines, memscr, mempoint,  _
ppscrol, ppscrol2, pfocus, pfocus2, nogput, palt, altdw, iskey, withkey, focus, mkey$, pointer, pform, form, arrow2, keycur, pkeycur, x3, x4, y3, y4, remlines, turb, txtexist, dirfind, pscr10, hidelink, searching, arrow, finger, CURSORS%, t#, dt$,  _
gridsize%, suspend, nolink, pscr9, workfile$, eror
COMMON SHARED pfoc, pfoc2, barlen, wids, x7, y7, x8, y8, saverest, aut, nokey, searchall, web, alrea2, lassear, fend2, forward, backfor, already, move1, py4, round, txt$, textend, highl, searloc, lin, sear, pscr6, pscr3, scrol3, todo$, fselect$,  _
fend, ptime$, pv2.ico, lasrec, set, v.aut, v.pbar, v.ico, v.tm, v.lf, v.ef, pv.tm, pv.ef, pv.aut, pv.pbar, pv.ico, pv.lf, savfile$, openf, tru1, lab, mov, nomsg, asshyp, pc3, hyploc, load#, pgup$, pgdw$, up$, down$, lef$, rig$, home2$, end2$, del$,  _
delay2#, delay5#, messa, tru, idir2$, idir$, pc4, pscr, scroll, scrol2, py2, curpos, pcur2, pcur, curc, delay6#, pkey$, colom, pcolom, char, marea, inp$, scrol, ych, howm, pbar, bar, proceed, px, py, plb, prb, plb2, pc2, pc, c, pend, hold, cho _
, LB%, RB%, Xmouse%, Ymouse%
COMMON SHARED dataform$, key$, lfocus1, lfocus2, lfocus3, lfocus4, lfocus5, menus, hold2, pgputy, pmempoint, list.value$, list.index2, listb, prevpage, firstime, frmback, tabbed, lastfocus, mouseret3, Xmouse2, Ymouse2, menumouse,  _
mess() AS STRING, remcured, drag, d2, e2, f2, g2, d3, e3, f3, g3, upline, downline, rightline, leftline, dragscr, dragscr2, savecont, pscrboun() AS INTEGER, pmouses2() AS INTEGER, pmouse() AS  _
INTEGER, submen, pushmen, tabulate, bc, prevscr() AS INTEGER, prevscr2() AS INTEGER, mouseret2, options, scrboun() AS boun, pmouses() AS area, prev() AS coor, FontHdr AS FontHeader, mouse$, checks, mscrx, mscry, gputy, fit, py3, controlstart, hide, max
COMMON SHARED DTA2 AS STRING * 64, OutRegs AS RegTypeX, InRegs AS RegTypeX, FCB AS XFCBType, Registers AS RegtypeX, DTA AS DTAStructure, ALLENTRIES, FILESONLY, DIRSONLY, FALSE, TRUE, FINDFIRST, FINDNEXT, NOTMOREFOUND, ENTRYNOTMATCHEDFILTER, ENTRYFOUND
COMMON SHARED prevcur, dropped, listselect2$, save1, save2, save3, save1d, save2d, edit, compile, dragscr3, prevscr3() AS INTEGER, viewonly, modified, menupresent, dropdownpresent, listhighlfore, listhighlback, endis5count, home$, end$
COMMON SHARED lcnts1, lcnts2, lcnts3, lcnts4, lcnts5, nogridfoc, pgputy2, edit.row, edit.col, edit.home, edit.end, text.col, text.home, text.end, combo.col, combo.home, combo.end, spin.col, spin.home, spin.end, list.home, list.end, endistype
COMMON SHARED edit.Uscroll, list.Uscroll, edit.Lscroll, list.Lscroll, onsearch, editendis, msgmax, realsub, showxy, windowgrid

CLEAR , , 2000 'Modify this if needed

'The following lines can be modified

'User defined variables

 'Specify the maximum number of object message from 1 TO 300
 'The lesser the value the more the available space for
 'strings and arrays
MSGMAX = 50
           
 'Data file
DATFILE$ = "QBOBJECT.DAT"

 'Mouse file
MOUSEFILE$ = "MOUSE.DAT"

 'Font file
FONTFILE$ = "FONTS.DAT"

 'Message when XMS driver is not detected
XMSNOTFOUND$ = "XMS driver not installed"

 'Message when there's not enough XMS space
XMSLOW$ = "Insufficient XMS memory"

 'Message when there's not enough XMS handler
XMSHANDLERLOW$ = "Insufficient XMS Handler"

 'Message when no mouse detected
MOUSENOTFOUND$ = "Mouse not detected"


'The following lines may not be modified

LSET FCB.XFlag = CHR$(255)
LSET FCB.Rsrv1 = STRING$(5, 0)

ALLENTRIES = 0
FILESONLY = 1
DIRSONLY = 2
FALSE = 0
TRUE = NOT FALSE
FINDFIRST = &H4E00
FINDNEXT = &H4F00
NOTMOREFOUND = 0
ENTRYNOTMATCHEDFILTER = 1
ENTRYFOUND = 2

DIM SHARED winpos(300) AS winp
DIM SHARED slice(1 TO 28, 1 TO 80) AS slic
DIM SHARED lists(300) AS STRING
pgup$ = CHR$(0) + CHR$(73)
pgdw$ = CHR$(0) + CHR$(81)
up$ = CHR$(0) + CHR$(72)
down$ = CHR$(0) + CHR$(80)
lef$ = CHR$(0) + CHR$(75)
rig$ = CHR$(0) + CHR$(77)
home2$ = CHR$(0) + CHR$(119)
end2$ = CHR$(0) + CHR$(117)
home$ = CHR$(0) + CHR$(71)
end$ = CHR$(0) + CHR$(79)
del$ = CHR$(0) + CHR$(83)
marea = 0
remcured = 1
REDIM SHARED INTRPT(1 TO 50)
DEF SEG = VARSEG(INTRPT(1))
Address = VARPTR(INTRPT(1))
FOR i = 0 TO 99
	READ a
	POKE Address + i, a
NEXT
DATA 85,139,236,86,87,30,139,118,6,139,4,139,92,2,139,76,4,139,84,6
DATA 139,108,8,139,124,12,142,68,18,255,116,10,131,124,18,255,117,2,30,7
DATA 131,124,16,255,116,3,142,92,16
DATA 94,205,33,85,139,236,30,86,142,94,2,139,118,14,137,4,137,92,2,137,76,4
DATA 137,84,6,143,68,10,143,68,16,143,68,8,137,124,12,140,68,18,156,143,68,14
DATA 95,95,94,93,202,2,0

'Check setting
IF MSGMAX = 0 THEN MSGMAX = 50
IF MSGMAX > 300 THEN MSGMAX = 300

IF DATFILE$ = "" THEN DATFILE$ = "QBOBJECT.DAT"
IF MOUSEFILE$ = "" THEN MOUSEFILE$ = "MOUSE.DAT"
IF FONTFILE$ = "" THEN FONTFILE$ = "FONTS.DAT"
IF XMSNOTFOUND$ = "" THEN XMSNOTFOUND$ = "XMS driver not installed"
IF XMSLOW$ = "" THEN XMSLOW$ = "Insufficient XMS memory"
IF XMSHANDLERLOW$ = "" THEN XMSHANDLERLOW$ = "Insufficient XMS Handler"
IF MOUSENOTFOUND$ = "" THEN MOUSENOTFOUND$ = "Mouse not detected"

'checkfiles
PRINT
a$ = "File not found - "
IF NOT exist(DATFILE$) THEN
  PRINT a$ + DATFILE$
  END
END IF
IF NOT exist(MOUSEFILE$) THEN
  PRINT a$ + MOUSEFILE$
  END
END IF
IF NOT exist(FONTFILE$) THEN
  PRINT a$ + FONTFILE$
  END
END IF


'Initialization for mouse

mouse$ = SPACE$(57)
DIM SHARED CURSOR(16) AS MouseCursor
DIM SHARED memo(400) AS STRING
DIM SHARED mess(msgmax) AS STRING
DIM SHARED alt(28) AS INTEGER

CLOSE
b$ = "Invalid file - "
OPEN DATFILE$ FOR RANDOM AS 1 LEN = 4
  IF LOF(1) <> 110 THEN PRINT b$ + DATFILE$: END
  FOR a = 1 TO 28
    GET 1, a, alt(a)
  NEXT
CLOSE
OPEN MOUSEFILE$ FOR RANDOM AS 1 LEN = 4
IF LOF(1) <> 4716 THEN PRINT b$ + MOUSEFILE$: END
FOR i% = 1 TO 57
  GET 1, i%, a$
  h$ = CHR$(VAL("&H" + a$))
  MID$(mouse$, i%, 1) = h$
NEXT i%
d = 58
FOR i% = 0 TO 16
  GET 1, d, x%
  d = d + 1
  GET 1, d, y%
  d = d + 1
  CURSOR(i%).HotSpotX = x%
  CURSOR(i%).HotSpotY = y%
  CURSOR(i%).Image = SPACE$(64)
  FOR j% = 1 TO 64
    GET 1, d, a$
    d = d + 1
    h$ = CHR$(VAL("&H" + a$))
    MID$(CURSOR(i%).Image, j%, 1) = h$
  NEXT j%
NEXT i%
CLOSE
ms% = Mouseinit%
IF NOT ms% THEN PRINT : PRINT MOUSENOTFOUND$: SLEEP 1
DIM SHARED prevscr(1 TO 5) AS INTEGER
DIM SHARED prevscr2(1 TO 5) AS INTEGER
DIM SHARED prevscr3(1 TO 5) AS INTEGER

DIM SHARED pmouses2(5) AS INTEGER
DIM SHARED pmouse(5) AS INTEGER
DIM SHARED pscrboun(5) AS INTEGER
DIM SHARED pwinpos(5) AS INTEGER

a = XMSinit
IF a = -1 THEN PRINT XMSNOTFOUND$: END
XMSinfo m, l
totalxms = l
IF l < 1000 THEN PRINT XMSLOW$: END
FOR a = 1 TO 4
  prevscr(a) = XMSalloc(65)
  prevscr2(a) = XMSalloc(65)
  prevscr3(a) = XMSalloc(65)
  pwinpos(a) = XMSalloc(25)
  pmouse(a) = XMSalloc(65)
  pmouses2(a) = XMSalloc(65)
  pscrboun(a) = XMSalloc(25)
NEXT

dragscr = XMSalloc(65)
dragscr2 = XMSalloc(65)
dragscr3 = XMSalloc(65)

upline = XMSalloc(65)
downline = XMSalloc(65)
leftline = XMSalloc(65)
rightline = XMSalloc(65)

pushmen = XMSalloc(65)
submen = XMSalloc(65)
mscr = XMSalloc(65)

save1 = XMSalloc(65)
save2 = XMSalloc(65)
save3 = XMSalloc(65)
XMSinfo m, l
IF l = 0 THEN PRINT XMSHANDLERLOW$: FREEXMS: END

SCREEN 12
hide = -1
CURSORS% = 0
setpointer 0
mshow

DIM SHARED chr(150) AS STRING

DIM SHARED area1%(20000)

DIM DataString(8300) AS INTEGER
DIM SHARED fontbuf(0) AS STRING * 16384
OPEN FONTFILE$ FOR BINARY AS #1
IF LOF(1) <> 2080 THEN PRINT b$ + FONTFILE$: END
  offs% = 1
  GET #1, , FontHdr
  FOR y% = 1 TO (FontHdr.with * FontHdr.Hite * 128) \ 16
    GET #1, , In%
    FOR x% = 0 TO 15
      IF ((In%) AND (2 ^ x%)) \ (2 ^ x%) = 1 THEN
       MID$(fontbuf(0), offs%, 1) = CHR$(1)
      END IF
      offs% = offs% + 1
     NEXT x%
   NEXT y%
CLOSE
DIM SHARED prev(1 TO 6) AS coor

DIM SHARED m(320) AS area

DIM SHARED scrboun(320) AS boun
DIM SHARED pmouses(320) AS area

'CONSTANT COLORS
CONST BLACK = 0, BLUE = 1, GREEN = 2, CYAN = 3, RED = 4, MAGENTA = 5, BROWN = 6, WHITE = 7, GREY = 8, BBLUE = 9, BGREEN = 10, BCYAN = 11, BRED = 12, BMAGENTA = 13, YELLOW = 14, BWHITE = 15

